diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/art.c tin-2.6.5/src/art.c
--- tin-2.6.4/src/art.c	2024-12-21 17:43:55.000000000 +0100
+++ tin-2.6.5/src/art.c	2025-12-18 19:57:23.664352406 +0100
@@ -2293,13 +2357,20 @@ read_overview(
 						break;
 
 					case 2:	/* From: */
-						if (*ptr)
-							build_mailbox_list(art, ptr);
-						else {
-							struct t_mailbox *mb;
+						if (*ptr) {
+							if (!flag || serverrc.cache_overview_files)
+								art->from_raw = hash_str(ptr);
+							if (flag)
+								build_mailbox_list(art, ptr);
+						} else {
+							if (!flag || serverrc.cache_overview_files)
+								art->from_raw = hash_str("");
+							if (flag) {
+								struct t_mailbox *mb;
 
-							if ((mb = add_mailbox(art)) != NULL)
-								mb->from = hash_str("");
+								if ((mb = add_mailbox(art)) != NULL)
+									mb->from = hash_str("");
+							}
 #ifdef DEBUG
 							if ((debug & DEBUG_NNTP) && verbose > 1)
 								debug_print_file("NNTP", "%s(%"T_ARTNUM_PFMT") empty overview-field %s", nntp_caps.over_cmd, artnum, ofmt[count].name);
@@ -2377,13 +2448,13 @@ read_overview(
 						if ((q = parse_header(ptr, "Xref", FALSE, FALSE, FALSE)) != NULL) {
 							FreeIfNeeded(art->xref); /* if field is listed more than once in overview.fmt */
 							art->xref = my_strdup(q);
-						}
+						} else {
+							FreeAndNull(art->xref);
 #ifdef DEBUG
-						else {
 							if ((debug & DEBUG_NNTP) && verbose > 1)
 								debug_print_file("NNTP", "%s(%"T_ARTNUM_PFMT") bogus overview-field %s %s", nntp_caps.over_cmd, artnum, ofmt[count].name, ptr);
-						}
 #endif /* DEBUG */
+						}
 						continue;
 					}
 					/*
@@ -2403,8 +2474,7 @@ read_overview(
 						if ((q = parse_header(ptr, "Path", FALSE, FALSE, FALSE)) != NULL) {
 							if (!path_found)
 								path_found = TRUE;
-							FreeIfNeeded(art->path);
-							art->path = my_strdup(q);
+							art->path = hash_str(q);
 #ifdef DEBUG
 							if ((debug & DEBUG_NNTP) && verbose > 1 && strcasecmp(ofmt[count].name, "Path:"))
 								debug_print_file("NNTP", "\tUsing as \"Path:\" not \"%s\"", ofmt[count].name);
@@ -2439,18 +2509,19 @@ read_overview(
 
 	free(group_msg);
 #ifdef USE_ZLIB
-	if (gfp) {
+	if (gzfp) {
 		free(buf);
-		gzclose_r(gfp);
-		fclose(fp);
-	} else
+		gzclose_r(gzfp);
+		if (fstat(dup_fd, &st) == 0 || errno != EBADF) /* dup_fd still open? */
+			close(dup_fd);
+	}
 #endif /* USE_ZLIB */
-		TIN_FCLOSE(fp);
+	TIN_FCLOSE(fp);
 
 	if (tin_errno)
 		return -1;
 
-#if defined(NNTP_ABLE) && defined(XHDR_XREF)
+#ifdef NNTP_ABLE
 	if (read_news_via_nntp && !read_saved_news && !xref_supported && nntp_caps.hdr_cmd) {
 		char cbuf[HEADER_LEN];
 		static t_bool found;
@@ -2464,7 +2535,7 @@ read_overview(
 			if (nntp_caps.type == CAPABILITIES && nntp_caps.list_headers) {
 				if (!*nntp_caps.headers_range) {
 					found = FALSE;
-					switch (new_nntp_command("LIST HEADERS RANGE", 215, cbuf, sizeof(cbuf))) {
+					switch (new_nntp_command("LIST HEADERS RANGE", 215, NULL, 0)) {
 						case 215:
 							while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #	ifdef DEBUG
@@ -2516,9 +2587,11 @@ read_overview(
 					if (!strstr(ptr, "(none)")) {
 						if ((q = strchr(ptr, ' ')) == NULL) /* skip article number */
 							continue;
+
 						ptr = q;
 						while (*ptr && isspace((unsigned char) *ptr))
 							++ptr;
+
 						if ((q = strchr(ptr, '\n')) != NULL)
 							*q = '\0';
 						art->xref = my_strdup(ptr);
@@ -2538,7 +2611,7 @@ read_overview(
 			free(group_msg);
 		}
 	}
-#endif /* NNTP_ABLE && XHDR_XREF */
+#endif /* NNTP_ABLE */
 
 	if (local) {
 #ifdef NNTP_ABLE
@@ -2565,6 +2638,7 @@ read_overview(
 					 * Path: is in the servers overview so let the next
 					 * read_overview() fetch them
 					 */
+					hash_reclaim();
 					free_art_array();
 					free_msgids();
 					top_art = 0;
@@ -2611,44 +2685,32 @@ read_overview(
  *	7. Byte count     (Skipped - not used)     [mandatory]
  *	8. Line count     (ie. 23)                 [mandatory]
  *	9. Xref: line     (ie. alt.test:389)       [optional]
- *
- * TODO: as we don't use the original data, we currently can't store
- *       the data (from/subject) in the original charset (we don't store
- *       that info). this has the advantage that we can avoid raw 8bit data
- *       in our overviews, but the disadvantage that we might store the data
- *       with a wrong charset and thus lose information. a similar problem
- *       exists with the data for the from:-line, we don't store it in the
- *       original format, whenever our from-parser (partially) fails we'll
- *       lose information in our overviews (but those couldn't be handled
- *       by tin anyway, so this is not a real problem).
- *       long-term solution: store the original data in the overview
- *       (tin has to handle raw 8bit data and other ugly stuff in the
- *       overviews anyway and thus we preserver as much info as possible)
- *       this would require some changes in read_overview() and
- *       parse_headers(): don't do the decoding/unfolding there, but in a
- *       second pass right after write_overview(), or two additional fields
- *       which hold the raw data for from/subject. the latter has the
- *       disadvantage that it costs (much) more memory.
  */
-static void
+void
 write_overview(
 	struct t_group *group)
 {
 	FILE *fp;
+	char *q, *ref;
+	char date[30];
 	int i;
 	struct t_article *article;
-#ifdef CHARSET_CONVERSION
-	int c = -1;
-#endif /* CHARSET_CONVERSION */
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#if defined(HAVE_SETLOCALE) && !defined(NO_LOCALE)
+	const char *lc_all;
+#endif /* HAVE_SETLOCALE && defined(NO_LOCALE) */
+#if defined(HAVE_FCHMOD) || defined(USE_ZLIB)
 	int fd;
-	gzFile gfp;
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#endif /* HAVE_FCHMOD || USE_ZLIB */
+#ifdef USE_ZLIB
+	int dup_fd;
+	gzFile gzfp;
+	struct stat st;
+#endif /* USE_ZLIB */
 
 	/*
 	 * Can't write or caching is off or getart_limit is set
 	 */
-	if (no_write || !tinrc.cache_overview_files || ((cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit) != 0)
+	if (no_write || !serverrc.cache_overview_files || (getart_limit_set_from_scope(group) ? group->attribute->getart_limit : (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit) != 0)
 		return;
 
 	if ((fp = open_xover_fp(group, "w", T_ARTNUM_CONST(0), T_ARTNUM_CONST(0), FALSE)) == NULL)
@@ -2656,12 +2718,24 @@ write_overview(
 
 	BegStopWatch();
 
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
+#if defined(HAVE_FCHMOD) || defined(USE_ZLIB)
 	fd = fileno(fp);
-	if ((gfp = gzdopen(fd, tinrc.compress_overview_files ? "w3" : "wT")) != Z_NULL) {
-		/* gzbuffer(gfp, (tinrc.compress_overview_files ? 4 : 1) * 32768); */ /* the 8k default is ok for us */
+#endif /* HAVE_FCHMOD || USE_ZLIB*/
+#ifdef USE_ZLIB
+	if (fd == -1) { /* paranoid */
+		fclose(fp);
+		return;
 	}
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+	if ((dup_fd = dup(fd)) != -1) {
+		if ((gzfp = gzdopen(dup_fd, serverrc.compress_overview_files ? "w3" : "wT")) == Z_NULL)
+			close(dup_fd);
+#	if 0 /* the 8k default is ok for us */
+		else
+			gzbuffer(gzfp, (serverrc.compress_overview_files ? 4 : 1) * 32768);
+#	endif /* 0 */
+	} else
+		gzfp = Z_NULL;
+#endif /* USE_ZLIB */
 
 	if (group->attribute && group->attribute->sort_article_type != SORT_ARTICLES_BY_NOTHING)
 		SortBy(artnum_comp);
@@ -2669,53 +2743,36 @@ write_overview(
 	/*
 	 * Needed to preserve uniqueness in hashed private overview files
 	 */
-	FPRINTF(GFP(fp), "%s\n", group->name);
-
-#ifdef CHARSET_CONVERSION
-	/* get undeclared_charset number if required */
-	if (group->attribute && group->attribute->undeclared_charset && *group->attribute->undeclared_charset) {
-		for (i = 0; txt_mime_charsets[i] != NULL; i++) {
-			if (!strcasecmp(*group->attribute->undeclared_charset, txt_mime_charsets[i])) {
-				c = i;
-				break;
-			}
-		}
-	}
-#endif /* CHARSET_CONVERSION */
+#ifdef USE_ZLIB
+	if (gzfp)
+		gzprintf(gzfp, "%s\n", group->name);
+	else
+#endif /* USE_ZLIB */
+		fprintf(fp, "%s\n", group->name);
 
 	if (batch_mode && verbose > 1)
 		wait_message(0, _(txt_writing_group), group->name);
 
-	for_each_art(i) {
-		char *p, *q, *ref;
+#if defined(HAVE_SETLOCALE) && !defined(NO_LOCALE)
+	/*
+	 * Unlocalized date-header, as LC_ALL affects isprint() and co.
+	 * but we don't want to always switch it in the loop we have to
+	 * temporary set LC_CTYPE instead
+	 */
+	if (getenv("LC_ALL") != NULL) {
+		lc_all = setlocale(LC_ALL, NULL);
+		setlocale(LC_CTYPE, lc_all);
+		setlocale(LC_ALL, "POSIX");
+	} else
+		setlocale(LC_TIME, "POSIX");
+#endif /* HAVE_SETLOCALE && !NO_LOCALE */
 
+	for_each_art(i) {
 		article = &arts[i];
 
 		if (article->thread != ART_EXPIRED && article->artnum >= group->xmin) {
 			ref = NULL;
 
-			if (group->attribute && !group->attribute->post_8bit_header) { /* write encoded data */
-				/*
-				 * TODO: instead of tinrc.mm_local_charset we'd better use UTF-8
-				 *       here and in print_from() in the CHARSET_CONVERSION case.
-				 *       note that this requires something like
-				 *          buffer_to_network(&article->subject, "UTF-8");
-				 *       right before the rfc1522_encode() call.
-				 *
-				 *       if we would cache the original undecoded data, we could
-				 *       ignore stuff like this.
-				 */
-				p = rfc1522_encode(article->subject, tinrc.mm_local_charset, FALSE);
-				/* as the subject might now be folded we have to unfold it */
-				unfold_header(p);
-			} else { /* raw data */
-				p = my_strdup(article->subject);
-#ifdef CHARSET_CONVERSION
-				if (group->attribute && group->attribute->undeclared_charset && *group->attribute->undeclared_charset && c != -1) /* use undeclared_charset if set (otherwise local charset is used) */
-					buffer_to_network(&p, c);
-#endif /* CHARSET_CONVERSION */
-			}
-
 			/*
 			 * replace any '\t's with ' ' in the references-data
 			 *
@@ -2735,58 +2792,54 @@ write_overview(
 				}
 			}
 
-			{
-				char date[30];
-#if defined(HAVE_SETLOCALE) && !defined(NO_LOCALE)
-				char *old_lc_all = NULL, *old_lc_time = NULL;
+			if (!my_strftime(date, sizeof(date) - 1, "%d %b %Y %H:%M:%S GMT", gmtime(&article->date)))
+				snprintf(date, sizeof(date) - 1, "01 Jan 1970 00:00:00 UTC");
 
-				/* Unlocalized date-header */
-				if (getenv("LC_ALL") != NULL) {
-					old_lc_all = my_strdup(setlocale(LC_ALL, NULL));
-					setlocale(LC_ALL, "POSIX");
-				} else {
-					old_lc_time = my_strdup(setlocale(LC_TIME, NULL));
-					setlocale(LC_TIME, "POSIX");
-				}
-#endif /* HAVE_SETLOCALE && !NO_LOCALE */
-
-				if (!my_strftime(date, sizeof(date) - 1, "%d %b %Y %H:%M:%S GMT", gmtime(&article->date)))
-					snprintf(date, sizeof(date) - 1, "01 Jan 1970 00:00:00 UTC");
-
-				FPRINTF(GFP(fp), "%"T_ARTNUM_PFMT"\t%s\t%s\t%s\t%s\t%s\t%d\t%d",
+#ifdef USE_ZLIB
+			if (gzfp)
+				gzprintf(gzfp, "%"T_ARTNUM_PFMT"\t%s\t%s\t%s\t%s\t%s\t%d\t%d",
 					article->artnum,
-					p,
-#ifdef CHARSET_CONVERSION
-					print_from(group, article, c),
-#else
-					print_from(group, article, -1),
-#endif /* CHARSET_CONVERSION */
+					article->subject_raw,
+					article->from_raw,
+					date,
+					BlankIfNull(article->msgid), BlankIfNull(ref),
+					0 /* bytes */, article->line_count);
+			else
+#endif /* USE_ZLIB */
+				fprintf(fp, "%"T_ARTNUM_PFMT"\t%s\t%s\t%s\t%s\t%s\t%d\t%d",
+					article->artnum,
+					article->subject_raw,
+					article->from_raw,
 					date,
-					BlankIfNull(article->msgid),
-					BlankIfNull(ref),
-					0,	/* bytes */
+					BlankIfNull(article->msgid), BlankIfNull(ref),
+					0 /* bytes */,
 					article->line_count);
-#if defined(HAVE_SETLOCALE) && !defined(NO_LOCALE)
-				/* change back LC_* */
-				if (old_lc_all != NULL) {
-					setlocale(LC_ALL, old_lc_all);
-					free(old_lc_all);
-				} else if (old_lc_time != NULL) {
-					setlocale(LC_TIME, old_lc_time);
-					free(old_lc_time);
-				}
-#endif /* HAVE_SETLOCALE && !NO_LOCALE */
-			}
 
-			if (article->xref)
-				FPRINTF(GFP(fp), "\tXref: %s", article->xref);
+			if (article->xref) {
+#ifdef USE_ZLIB
+				if (gzfp)
+					gzprintf(gzfp, "\tXref: %s", article->xref);
+				else
+#endif /* USE_ZLIB */
+					fprintf(fp, "\tXref: %s", article->xref);
+			}
 
-			if (article->path)
-				FPRINTF(GFP(fp), "\tPath: %s", article->path);
+			if (article->path) {
+#ifdef USE_ZLIB
+				if (gzfp)
+					gzprintf(gzfp, "\tPath: %s", article->path);
+				else
+#endif /* USE_ZLIB */
+					fprintf(fp, "\tPath: %s", article->path);
+			}
 
-			FPRINTF(GFP(fp), "\n");
+#ifdef USE_ZLIB
+			if (gzfp)
+				gzprintf(gzfp, "\n");
+			else
+#endif /* USE_ZLIB */
+				fprintf(fp, "\n");
 
-			free(p);
 			if (article->refs) {
 				FreeIfNeeded(ref);
 			}
@@ -2794,17 +2847,28 @@ write_overview(
 		if (i % (MODULO_COUNT_NUM * 20) == 0)
 			show_progress(_(txt_writing_overview), i, top_art);
 	}
+
+#if defined(HAVE_SETLOCALE) && !defined(NO_LOCALE)
+	/* change back LC_* */
+	setlocale(LC_TIME, "");
+	setlocale(LC_CTYPE, "");
+	setlocale(LC_ALL, "");
+#endif /* HAVE_SETLOCALE && !NO_LOCALE */
+
 #ifdef HAVE_FCHMOD
-	fchmod(fileno(fp), (mode_t) (S_IWUSR|S_IRUGO));
+	fchmod(fd, (mode_t) (S_IWUSR|S_IRUGO));
 #else
 #	ifdef HAVE_CHMOD
 		chmod(find_nov_file(group, R_OK), (mode_t) (S_IWUSR|S_IRUGO));
 #	endif /* HAVE_CHMOD */
 #endif /* HAVE_FCHMOD */
-#if defined(USE_ZLIB) && defined(CPP_DOES_CONCAT)
-	if (gfp)
-		gzclose_w(gfp);
-#endif /* USE_ZLIB && CPP_DOES_CONCAT */
+#ifdef USE_ZLIB
+	if (gzfp) {
+		gzclose_w(gzfp);
+		if (fstat(dup_fd, &st) == 0 || errno != EBADF) /* dup_fd still open? */
+			close(dup_fd);
+	}
+#endif /* USE_ZLIB */
 	fclose(fp);
 	EndStopWatch("write_overview()");
 }
@@ -2842,6 +2906,11 @@ find_nov_file(
 	struct stat sb;
 	static char nov_file[PATH_LEN];
 	static t_bool once_only = FALSE;	/* Trap things that are done only 1 time */
+#ifdef USE_ZLIB
+	int fd, dup_fd;
+	gzFile gzfp;
+	struct stat st;
+#endif /* USE_ZLIB */
 
 	if (group == NULL || (mode != R_OK && mode != W_OK))
 		return NULL;
@@ -2923,7 +2992,7 @@ find_nov_file(
 			 * We only get here when private overviews are going to be used
 			 * Go no further if they are explicitly turned off
 			 */
-			if (!tinrc.cache_overview_files)
+			if (!serverrc.cache_overview_files)
 				return NULL;
 
 			/*
@@ -2990,45 +3059,62 @@ find_nov_file(
 			break;
 
 #ifdef USE_ZLIB /* TODO: avoid fixed length buffer */
-		{
-			int fd = fileno(fp);
-			gzFile gfp = NULL;
-
-			if ((gfp = gzdopen(fd, "r")) != Z_NULL) {
-				ptr = my_calloc(1, 32768 + 1);
-				if (gzgets(gfp, ptr, 32768) != Z_NULL) {
-					str_trim(ptr);
-					gzclose_r(gfp);
+		if ((fd = fileno(fp)) == -1) { /* paranoid */
+			fclose(fp);
+			continue; /* try next */
+		}
+		gzfp = Z_NULL;
+		if ((dup_fd = dup(fd)) != -1) {
+			if ((gzfp = gzdopen(dup_fd, "r")) == Z_NULL) {
+				close(dup_fd);
+				fclose(fp);
+				continue; /* try next */
+			} else {
+				/* as we just read the 1st line, no gzdirect() check */
+				ptr = my_calloc(1, 4096 + 1); /* group name is no longer than 497 */
+				if (gzgets(gzfp, ptr, 4096) == Z_NULL) {
+					free(ptr);
+					gzclose_r(gzfp);
+					if (fstat(dup_fd, &st) == 0 || errno != EBADF) /* dup_fd still open? */
+						close(dup_fd);
 					fclose(fp);
-					fp = NULL;
-					if (strcmp(ptr, group->name)) {
-						free(ptr);
-						continue;
-					} else {
-						free(ptr);
-						break;
-					}
+					continue; /* try next */
 				}
-				gzclose_r(gfp);
+				str_trim(ptr);
+				gzclose_r(gzfp);
+				if (fstat(dup_fd, &st) == 0 || errno != EBADF) /* dup_fd still open? */
+					close(dup_fd);
 				fclose(fp);
 				fp = NULL;
-				free(ptr);
+				if (strcmp(ptr, group->name)) {
+					free(ptr);
+					continue; /* try next */
+				} else { /* we have a match !*/
+					free(ptr);
+					break;
+				}
 			}
 		}
-#else
-		if ((ptr = tin_fgets(fp, FALSE)) != NULL) { /* grab 1st line */
-			if (strcmp(ptr, group->name)) {/* name mismatch try next */
-				fclose(fp);
-				fp = NULL;
-				continue;
+		if (!gzfp)
+#endif /* USE_ZLIB */
+		{
+			if ((ptr = tin_fgets(fp, FALSE)) != NULL) { /* grab 1st line */
+				if (strcmp(ptr, group->name)) {/* name mismatch try next file */
+					fclose(fp);
+					fp = NULL;
+					continue;
+				}
 			}
 		}
-#endif /* USE_ZLIB */
 		/* match, leave loop */
 		break;
 	}
+
+#ifndef USE_ZLIB
 	if (fp)
 		fclose(fp);
+#endif /* !USE_ZLIB */
+
 	return nov_file;
 }
 
@@ -3042,7 +3128,6 @@ do_update(
 {
 	int i, j, k = 0;
 	time_t beg_epoch = 0;
-	struct t_article *art;
 	struct t_group *group;
 
 	if (verbose)
@@ -3064,19 +3149,31 @@ do_update(
 		if (group->bogus || !group->subscribed)
 			continue;
 
-		if (!index_group(group)) {
+		if (!index_group(group, FALSE)) {
+#if 0
+			/*
+			 * can't see how this ever could leak, so why bother?
+			 * (next index_group() or tin_done() will take care
+			 * of the free()s and nothing else should modify arts[])
+			 * and if, why not also clear xref?
+			 */
+			struct t_article *art;
+
 			for_each_art(j) {
 				art = &arts[j];
 				FreeAndNull(art->refs);
 				FreeAndNull(art->msgid);
+				/* FreeAndNull(art->xref); */
 			}
+#endif /* 0 */
 			continue;
 		}
 
 		++k;
 
 		if (verbose) {
-			my_printf("%s %s\n", (catchup ? _(txt_catchup) : _(txt_updating)), group->name);
+			my_printf((catchup ? _(txt_catchup_group) : _(txt_updating_group)), group->name);
+			my_printf("\n");
 			my_flush();
 		}
 
@@ -3087,9 +3184,39 @@ do_update(
 	}
 
 	if (verbose) {
-		wait_message(0, _(txt_catchup_update_info),
-			(catchup ? _(txt_caughtup) : _(txt_updated)), k,
-			PLURAL(selmenu.max, txt_group), (unsigned long int) (time(NULL) - beg_epoch));
+		const char *action_fmt = catchup ? P_(txt_catchup_info_sp[0], txt_catchup_info_sp[1], k) : P_(txt_update_info_sp[0], txt_update_info_sp[1], k);
+		const char *elapsed_fmt;
+		char *action;
+		char *elapsed;
+		int n;
+		size_t len;
+		time_t tela = time(NULL) - beg_epoch;
+
+		if ((n = snprintf(NULL, 0, action_fmt, k)) < 0)
+			return;
+		len = (size_t) n + 1;
+		action = my_malloc(len);
+		if (snprintf(action, len, action_fmt, k) < 0) {
+			free(action);
+			return;
+		}
+
+		elapsed_fmt = P_(txt_n_second_sp[0], txt_n_second_sp[1], tela);
+		if ((n = snprintf(NULL, 0, elapsed_fmt, tela)) < 0) {
+			free(action);
+			return;
+		}
+		len = (size_t) n + 1;
+		elapsed = my_malloc(len);
+		if (snprintf(elapsed, len, elapsed_fmt, tela) < 0) {
+			free(action);
+			free(elapsed);
+			return;
+		}
+
+		wait_message(0, _(txt_catchup_update_info), action, elapsed);
+		free(action);
+		free(elapsed);
 	}
 }
 
@@ -3416,11 +3543,14 @@ set_article(
 	struct t_article *art)
 {
 	art->subject = NULL;
+	art->subject_raw = NULL;
 	art->date = (time_t) 0;
 	art->xref = NULL;
+	art->path = NULL;
 	art->msgid = NULL;
 	art->refs = NULL;
 	art->refptr = NULL;
+	art->from_raw = NULL;
 	art->mailbox.from = NULL;
 	art->mailbox.name = NULL;
 	art->mailbox.next = NULL;
@@ -3458,7 +3588,7 @@ valid_artnum(
 		cur <<= 1;
 
 	range = cur >> 1;
-	cur--;
+	--cur;
 
 	forever {
 		if (arts[cur].artnum == art)
@@ -3497,64 +3627,6 @@ find_artnum(
 }
 
 
-static char *
-print_from(
-	const struct t_group *group,
-	struct t_article *article,
-	int charset)
-{
-	char *p, *q;
-	static char from[PATH_LEN];
-	char single_from[PATH_LEN];
-	int c_needed = 0;
-	struct t_mailbox *mb = &article->mailbox;
-
-/*	if (!mb)
-		return from; */
-
-	*from = *single_from = '\0';
-
-	do {
-		if (mb->name != NULL) {
-			q = my_strdup(mb->name);
-#ifdef CHARSET_CONVERSION
-			if (charset != -1)
-				buffer_to_network(&q, charset);
-#else
-			(void) charset;
-#endif /* CHARSET_CONVERSION */
-			p = rfc1522_encode(mb->name, tinrc.mm_local_charset, FALSE);
-			unfold_header(p);
-			if (CHECK_RFC5322_SPECIALS(mb->name)) {
-				if (group->attribute)
-					snprintf(single_from, sizeof(single_from), "\"%s\" <%s>", group->attribute->post_8bit_header ? q : p, mb->from);
-				else
-					snprintf(single_from, sizeof(single_from), "\"%s\" <%s>", tinrc.post_8bit_header ? q : p, mb->from);
-			} else {
-				if (group->attribute)
-					snprintf(single_from, sizeof(single_from), "%s <%s>", group->attribute->post_8bit_header ? q : p, mb->from);
-				else
-					snprintf(single_from, sizeof(single_from), "%s <%s>", tinrc.post_8bit_header ? q : p, mb->from);
-			}
-
-			free(p);
-			free(q);
-		} else
-			snprintf(single_from, sizeof(single_from), "<%s>", mb->from);
-
-		if (strlen(from) + strlen(single_from) + /* strlen(", ") */ 2 < PATH_LEN) {
-			if (c_needed++)
-				strcat(from, ", ");
-			strcat(from, single_from);
-		}
-
-		mb = mb->next;
-	} while (mb);
-
-	return from;
-}
-
-
 /*
  * Open a group news overview file
  * Use NNTP XOVER where possible unless 'local' is set
